package cz.muni.fi.pb162.project.geometry;

/**
 * Class for triangle.
 *
 * @author Martina Linartová
 */

public class Triangle {
    private Vertex2D[] points = new Vertex2D[3];
    private Triangle[] triangles = new Triangle[3];

    /**
     * takes free Vertex2D
     * @return the triangle
     */
    public Triangle(Vertex2D x, Vertex2D y, Vertex2D z) {
        this.points[0] = x;
        this.points[1] = y;
        this.points[2] = z;
    }

    /**
     * gets Vertex
     * @return vertexes
     */
    public Vertex2D getVertex(int index) {
        if ((index >= 0) && (index <= 2)) {
            return points[index];
        }
        return null;
    }

    /**
     * sets Vertex
     * @return nothing
     */
    public void setVertex(int index, Vertex2D vertex) {
        if ((index >= 0) && (index <= 2)) {
            this.points[index] = vertex;
        }
    }

    /**
     * prints message about triangle
     * @return message
     */
    public String toString() {
        return "Triangle: vertices=" + this.points[0].toString() + " " +
                this.points[1].toString() + " " + this.points[2].toString();
    }

    /**
     * checks if it is divided
     * @return true or false
     */
    boolean isDivided() {
        if ((this.triangles[0] == null) || (this.triangles[1] == null) || (this.triangles[2] == null)) {
            return false;
        }
        return true;
    }

    /**
     * divides triangle
     * @return divided triangle
     */
    public boolean divide(){
        if (this.isDivided()) {
            return false;
        }

        Vertex2D midAC = this.points[0].createMiddle(this.points[1]);
        Vertex2D midAB = this.points[1].createMiddle(this.points[2]);
        Vertex2D midBC = this.points[2].createMiddle(this.points[0]);
        this.triangles[0] = new Triangle(this.points[1], midAB, midAC);
        this.triangles[1] = new Triangle(midAC, midBC, this.points[0]);
        this.triangles[2] = new Triangle(midBC, this.points[2], midAB);

        return true;
    }

    /**
     * gets smaller triangle
     * @return smaller triangle
     */
    public Triangle getSubTriangle(int index) {
        if ((index >= 0) && (index <= 2)) {
            return triangles[index];
        }
        return null;
    }
}
